#include "udp.h"

#define	BCAS_RATE	(21505)		//21.5Kbps

u32	ecm_sw = 0;
u8	ecm_data[2][30];
u32	ecm_key[2][4];
static const u8 ecm_cmd[4] = {0x90, 0x34, 0x00, 0x00};
u32 calced_ecm_key[2][2]={{0,0}, {0,0}};

typedef enum{
	FRAME_NOT,
	CMD_WAIT,
	ECM_REQUEST,
	ECM_REPLY
} BCAS_STATE;

void bcas_init(){

    UARTConfigure(UART3A, UART_ENABLE_PINS_TX_RX_ONLY);
    UARTSetFifoMode(UART3A, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART3A, UART_DATA_SIZE_8_BITS | UART_PARITY_EVEN | UART_STOP_BITS_2);
    UARTSetDataRate(UART3A, GetPeripheralClock(), BCAS_RATE);
    UARTEnable(UART3A, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));
}

void bcas_proc(){
	u32 i,m;
	static u32	len;
	static u8	buf[64];
	static u8	*p = buf;
	static u32	nskip = 0;
	static u32	nstore = sizeof(buf);
	static BCAS_STATE	state = FRAME_NOT;
	static u32	cmd_cnt = 0;

	for(;;){
		if(! U3ASTAbits.URXDA) break;

		m = U3ARXREG;

		if(nskip + nstore > sizeof(buf)){
			state = FRAME_NOT;
			p = buf;
			nskip = 0;
			nstore = sizeof(buf);
		}	

		if(nskip){
			--nskip;
			continue;
		}
		if(nstore){
			*p++ = (u8)m;
			--nstore;
		}
		if(nstore) continue;
		
		p = buf;
		
		if(state == FRAME_NOT){
			for(i = 3; i < sizeof(buf) - 4; i++)
				if(memcmp(buf + i, ecm_cmd, 4) == 0) break;
			if(i == sizeof(buf) - 4){
				nstore = sizeof(buf);
				continue;
			}
			i -= 3;
			for(;;){
				i += buf[i+2] + 4;
				if(i >= sizeof(buf)) break;
			}
			nskip = i - sizeof(buf);
			nstore = 7;
			state = CMD_WAIT;
			printf("BCS\n");
		}
		else if(state == CMD_WAIT){
			if(memcmp(buf + 3, ecm_cmd, 4) == 0){
				cmd_cnt = 0;
				nstore = buf[2] + 4 - 7;
				state = ECM_REQUEST;
			}
			else{
				if(++cmd_cnt < 20){
					nskip = buf[2] + 4 - 7;
					nstore = 7;
				}
				else{
					nstore = sizeof(buf);
					state = FRAME_NOT;
				}
			}
		}
		else if(state == ECM_REQUEST){
			//memcpy(ecm_data[(ecm_sw + 1) & 1], buf + 1, 30);
			nstore = 9 + (8 + 8);
			state = ECM_REPLY;
		}
		else if(state == ECM_REPLY){
			ecm_sw = (ecm_sw + 1) & 1;

			//memcpy(ecm_key[ecm_sw], buf + 9, (8 + 8));
			ecm_key[ecm_sw][0] = buf[ 9] + (buf[10] << 8) + (buf[11] << 16) + (buf[12] << 24);
			ecm_key[ecm_sw][1] = buf[13] + (buf[14] << 8) + (buf[15] << 16) + (buf[16] << 24);
			ecm_key[ecm_sw][2] = buf[17] + (buf[18] << 8) + (buf[19] << 16) + (buf[20] << 24);
			ecm_key[ecm_sw][3] = buf[21] + (buf[22] << 8) + (buf[23] << 16) + (buf[24] << 24);

			nskip = buf[2] + 4 - (9 + (8 + 8));
			nstore = 7;
			state = CMD_WAIT;

			if((calced_ecm_key[0][0] != ecm_key[ecm_sw][0]) || (calced_ecm_key[0][1] != ecm_key[ecm_sw][1])){
				calced_ecm_key[0][0] = ecm_key[ecm_sw][0];
				calced_ecm_key[0][1] = ecm_key[ecm_sw][1];
				encrypt_multi2(ecm_key[ecm_sw] + 0, wkey[0]);
			}
			if((calced_ecm_key[1][0] != ecm_key[ecm_sw][2]) || (calced_ecm_key[1][1] != ecm_key[ecm_sw][3])){
				calced_ecm_key[1][0] = ecm_key[ecm_sw][2];
				calced_ecm_key[1][1] = ecm_key[ecm_sw][3];
				encrypt_multi2(ecm_key[ecm_sw] + 2, wkey[1]);
			}
		}
	}
}
