#include <p32xxxx.h>

	.extern system_key

	.text
	.globl	encrypt_multi2
	.ent	encrypt_multi2
	.set	noreorder
/*
 * a0: u32 *emc
 * a1: u32 *wky
 *
 * t0: tmp
 * t1: tmp
 * t2: l
 * t3: r
 * t4: v00ff00ff
 * t5: sky
 */
 	#define	emc			$a0
 	#define	wky			$a1
 	
 	#define	l			$t2
 	#define	r			$t3
 	#define	v00ff00ff	$t4
 	#define	sky			$t5
 	
encrypt_multi2:
	la		sky, system_key
	li		v00ff00ff, 0x00ff00ff

	lw		$t0, 0(emc)
	rotr	$t1, $t0, 24
	and		$t1, v00ff00ff, $t1
	and		$t0, v00ff00ff, $t0
	rotr	$t0, $t0, 8
	or		l, $t0, $t1

	lw		$t0, 4(emc)
	rotr	$t1, $t0, 24
	and		$t1, v00ff00ff, $t1
	and		$t0, v00ff00ff, $t0
	rotr	$t0, $t0, 8
	or		r, $t0, $t1

	/*PI1()*/
	xor		r, r, l
	

	/*PI2(wk4)*/
	lw		$t0, 0(sky)
	addu	$t0, r, $t0
	
	rotr	$t1, $t0, 31
	addu	$t0, $t0, $t1
	subu	$t0, $t0, 1
	
	rotr	$t1, $t0, 28
	xor		$t0, $t1, $t0
	
	xor		l, l, $t0
	sw		l, 0(wky)
	
	/*PI3(wk5,wk6)*/
	lw		$t0, 4(sky)
	addu	$t0, l, $t0
	
	rotr    $t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	rotr	$t1, $t0, 24
	xor		$t0, $t1, $t0
	
	lw		$t1, 8(sky)
	addu	$t0, $t0, $t1
	
	rotr	$t1, $t0, 31
	subu	$t0, $t1, $t0
	
	rotr	$t1, $t0, 16
	or		$t0, $t0, l
	xor		$t0, $t0, $t1
	
	xor		r, r, $t0
	sw		r, 4(wky)
	
	/*PI4(wk7)*/
	lw		$t0, 12(sky)
	addu	$t0, r, $t0
	
	rotr	$t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	xor		l, l, $t0
	sw		l, 8(wky)
	
	/*PI1()*/
	xor		r, r, l
	sw		r, 12(wky)
	
	/*PI2(wk0)*/
	lw		$t0, 16(sky)
	addu	$t0, r, $t0
	
	rotr	$t1, $t0, 31
	addu	$t0, $t0, $t1
	subu	$t0, $t0, 1
	
	rotr	$t1, $t0, 28
	xor		$t0, $t1, $t0
	
	xor		l, l, $t0
	sw		l, 16(wky)
	
	/*PI3(wk1,wk2)*/
	lw		$t0, 20(sky)
	addu	$t0, l, $t0
	
	rotr    $t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	rotr	$t1, $t0, 24
	xor		$t0, $t1, $t0
	
	lw		$t1, 24(sky)
	addu	$t0, $t0, $t1
	
	rotr	$t1, $t0, 31
	subu	$t0, $t1, $t0
	
	rotr	$t1, $t0, 16
	or		$t0, $t0, l
	xor		$t0, $t0, $t1
	
	xor		r, r, $t0
	sw		r, 20(wky)

	/*PI4(wk3)*/
	lw		$t0, 28(sky)
	addu	$t0, r, $t0
	
	rotr	$t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	xor		l, l, $t0
	sw		l, 24(wky)
	
	/*PI1()*/
	xor		r, r, l
	sw		r, 28(wky)
	
	j		$ra
	nop
	
	.end	encrypt_multi2
