#ifndef _HARDWAREPROFILE_H_
#define _HARDWAREPROFILE_H_

#define		SYS_XTAL_FREQ		8000000 	// external Xtal, Hz
#define		PHY_ADDRESS		    0x1		    // address our NAT DP83848C PHY is mapped to

/*****************************************************************************
 * The number of ticks per second.  This is used to define timeouts
 * and must be defined before them.
 * This implementation uses the core timer
 *****************************************************************************/
#define TICKS_PER_SECOND        100

/*****************************************************************************
 * The interrupt priority (1-lowest to 7-highest) and sub-priority (0 to 3) for the timer used to generate the ticks
 *****************************************************************************/
#define	TICK_IPL		4
#define	TICK_SIPL		1


/*****************************************************************************
 * Define this symbol to use the embedded Ethernet Controller on PIC32MX7 family
 * Takes precedence, if defined, over MAC_ENC28J60 
 *****************************************************************************/
#define	MAC_EMBEDDED_PIC32

    /* The embedded Ethernet controller uses an external PHY
     * Here are configuration options
    */
#define	PHY_RMII			        // PHY runs in RMII mode

#define	PHY_CONFIG_ALTERNATE		// the alternate configuration used, else default

#endif	// _HARDWAREPROFILE_H_

