#include "udp.h"

//63Mbps(8bit read mix other DMA) (CS:max58Mbps)
#define PMP_CONTROL	(PMP_ON | PMP_MUX_OFF | PMP_READ_WRITE_EN |\
             		PMP_WRITE_POL_LO | PMP_READ_POL_LO)

#define PMP_MODE	(PMP_DATA_BUS_8 | PMP_MODE_MASTER2)

#define	PMP_PORT_PINS	PMP_PEN_OFF

#define	PMP_INTERRUPT	PMP_INT_OFF

#define PMP_BLKSZ	8	//MAX2ł8bytePʂœ]邽8ɃZbg
						//PMP SLAVEł4bytePʂœ]邽4ɃZbg

void decrypt_multi2(u32 *buf, u32 *wky, u32 len);
void decrypt_multi2_64(u32 *buf, u32 *wky, u32 len);

#define		TS_BUF_SIZE		188*256
u8			ts_buf[TS_BUF_SIZE + 4 + 8];
u8			*tx_buf[4];
_tx_stat	tx_buf_stat[8];	//TX_DONE, TX_STORED, TX_SENDING
sBuffDcpt	txh_dcpt[8];
sBuffDcpt	txd_dcpt[8];
u32			udp_idt_val;

u16 calc_chksum(u16 *buf, int bufsz);

u32 pmp_dma_ofs = 0;

void ts_init(){
	// setup the PMP
    mPMPOpen(PMP_CONTROL, PMP_MODE,PMP_PORT_PINS ,PMP_INTERRUPT);

	//DMA`l0 PMP -> Memory
	DmaChnOpen(0, 3, DMA_OPEN_AUTO);	//pri=3(hi)
	DmaChnSetEventControl(0, DMA_EV_START_IRQ(_EXTERNAL_0_IRQ));
	DmaChnSetTxfer(0, (void*)&PMDIN, ts_buf, 1, TS_BUF_SIZE, 8);
	DmaChnEnable(0);
	
	//DMA`l1
	DmaChnOpen(1, 0, DMA_OPEN_DEFAULT);	//pri=0(low)
	DmaChnSetTxfer(1, ts_buf, tx_buf[0], 188, 188, 188);
}

u32 enc_cnt = 0;
u32 noenc_cnt = 0;

u32 _buf[184/4];

void ts_proc(){
	u32 i,k,l;
	u32 type;
	struct	IPH	*iph;
	u32 dma_ptr;
	static u32 ptr = 0;
	static u32 buf_sel = 0;
	static u32 buf_idx = 0;
	static u32 udp_idt = 0;
	static u32 sync_lock = 0;
	static u32 sync_idx = 0;
	static u32 buf_ofs = 0;
	static u32 udp_ofs = 0;
	
	if(sync_lock == 0){
		if(DCH0CONbits.CHBUSY && DCH0CONbits.CHAEN){
			DCH0ECONSET = _DCH0ECON_CABORT_MASK;
			for(;;){
				if(!DCH0CONbits.CHBUSY) break;
			}
			DmaChnSetDstAdd(0, ts_buf);
			DCH0INTCLR = 0xff;
		}
		else if(DCH0INTbits.CHDHIF){
			DCH0INTCLR = _DCH0INT_CHDHIF_MASK;
			for(k = 0; k < 188; k++){
				if((ts_buf[k+188*0] == 0x47) && (ts_buf[k+188*1] == 0x47) &&
				   (ts_buf[k+188*2] == 0x47) && (ts_buf[k+188*3] == 0x47)){
					break;
				}
			}
			if(k != 188){
				pmp_dma_ofs = 4 - (k & 3);
				i = 188*4 + (k & (0x100 - PMP_BLKSZ));
				sync_idx = ptr = k - (k & (0x100 - PMP_BLKSZ));
				buf_idx = 0;
				for(l = 0; l < 0x100000; l++){
					if(!DCH0CONbits.CHBUSY) break;
				}
				DCH0DSIZ = i;
				DCH0CON = 0x0083;
				for(l = 0; l < 0x10000; l++){
					if(!DCH0CONbits.CHBUSY) break;
				}
				DmaChnSetDstAdd(0, ts_buf + pmp_dma_ofs);
				DCH0DSIZ = TS_BUF_SIZE;
				DCH0CON = 0x0093;
				sync_lock = 1;
				DCH0INTCLR = _DCH0INT_CHDHIF_MASK;
				*((u32 *)ts_buf + 0) = 0;
				printf("s=%d t=%d l=%d\n", k, k - (k & (0x100 - PMP_BLKSZ)), i-188*4);
			}
		}
		if(!DCH0CONbits.CHBUSY)
			DCH0CON = 0x0083;
	}
	else{
		if(tx_buf_stat[buf_sel] != TX_DONE) return;

		dma_ptr = DCH0DPTR;
		if(((ptr < dma_ptr) && (dma_ptr - ptr > 188)) ||
			((ptr > dma_ptr) && (ptr - dma_ptr < TS_BUF_SIZE - 188))){

			if(ts_buf[pmp_dma_ofs + ptr] != 0x47){
				sync_lock = 0;
				return;
			}
			if(ptr > TS_BUF_SIZE - 188){
				u8 *d = ts_buf + pmp_dma_ofs + TS_BUF_SIZE;
				u8 *s = ts_buf + pmp_dma_ofs;
				d[0] = s[0];
				d[1] = s[1];
				d[2] = s[2];
				d[3] = s[3];
				d[4] = s[4];
				d[5] = s[5];
				d[6] = s[6];
			}
			//memcpy(tx_buf[buf_sel] + 188 * buf_idx, ts_buf + ptr + pmp_dma_ofs, 188);

			type = ts_buf[pmp_dma_ofs + ptr + 3];
			if((type & 0xc0) && (type & 0x10)){//XNuLAyC[hL
				u32 odd_even = 0;
				if((type & 0xc0) == 0x80){
					odd_even = 1;
				}
				if(type & 0x20){//A_ve[VtB[hL
					u32 ofs;
					ofs = ts_buf[pmp_dma_ofs + ptr + 4] + 1;
					if(ofs < 184){
						decrypt_multi2((u32 *)(ts_buf + pmp_dma_ofs + ptr + 4 + ofs),
							(u32 *)(wkey[odd_even]), 184 - ofs);
					}		
				}
				else{
					decrypt_multi2_64((u32 *)(ts_buf + pmp_dma_ofs + ptr + 4),
						(u32 *)(wkey[odd_even]), 184);
				}
				ts_buf[pmp_dma_ofs + ptr + 3] &= 0x3f;
				enc_cnt++;
			}
			else{
				noenc_cnt++;
			}	

			if(buf_idx == 0){
				buf_ofs = sync_idx;
				udp_idt_val++;
				udp_idt_val |= 0x8000;
			}

			if(((buf_idx % 8) == 7) || (buf_idx == 251)){
				iph = (void *)txh_dcpt[buf_sel].pBuff + sizeof(struct ETH);
				txh_dcpt[buf_sel].nBytes = sizeof(struct ETH) + sizeof(struct IPH);
				txd_dcpt[buf_sel].pBuff = ts_buf + pmp_dma_ofs + buf_ofs;
				txd_dcpt[buf_sel].nBytes = 1472;
				if(buf_idx == 7){
					k = 0x2000;
					l = 1472 + sizeof(struct IPH) + sizeof(struct UDP);
					txh_dcpt[buf_sel].nBytes += sizeof(struct UDP);
					udp_ofs = 8;
				}
				else if(buf_idx == 255){
					k =  udp_ofs >> 3;
					l = (188*256) - (1472*32) + sizeof(struct IPH);
					txd_dcpt[buf_sel].nBytes = (188*256) - (1472*32);
				}
				else{
					k = 0x2000 + (udp_ofs >> 3);
					l = 1472 + sizeof(struct IPH);
				}
				iph->len   = (l >> 8) + (l << 8);
				iph->frags = (k >> 8) + (k << 8);

				iph->ident = (udp_idt_val >> 8) + (udp_idt_val << 8);
				iph->chksum = 0;
				iph->chksum = calc_chksum((u16 *)iph, sizeof(struct IPH));
				tx_buf_stat[buf_sel] = TX_STORED;

				if(++buf_sel == 8) buf_sel = 0;

				udp_ofs += 1472;
				buf_ofs += 1472;
			}
			if(++buf_idx == 256){
				buf_idx = 0;
			}
			ptr += 188;
			if(ptr >= TS_BUF_SIZE) ptr = sync_idx;
		}
	}
}
